// synchronous clear
// load and clear work regardless of enp or ent state
// worst case propagation delay is 35ns from clock to RCO for 74ls163a

module Counter_74LS163A ( clk, clr_bar, ld_bar, enp, ent, d, q, rco );
input clk, clr_bar, ld_bar, enp, ent;
input [3:0] d;
output [3:0] q;
output rco;

reg [3:0] q;

always @ (posedge clk)
begin
	#35
	if (~clr_bar) begin
		q = 0;
	end else if (~ld_bar) begin
		q = d;
	end else if (enp & ent) begin
		q = q + 1;
	end
end
  
assign rco = (q == 15);

endmodule