// synchronous and async clear
// load and clear work regardless of enp or ent state
// worst case propagation delay is 32ns for 74ls569a
// to cascade, connect rco_bar to cet_bar of next stage

module Counter_74LS569A ( clk, aclr_bar, sclr_bar, ld_bar, cep_bar, cet_bar, oe_bar, up_downbar, d, q, rco_bar, cco );
input clk, aclr_bar, sclr_bar, ld_bar, cep_bar, cet_bar, oe_bar, up_downbar;
input [3:0] d;
output [3:0] q;
output rco_bar, cco;

reg [3:0] q_int;

always @ (aclr_bar)
if (~aclr_bar) begin
	q_int = 0;
end

always @ (posedge clk)
begin
	if (aclr_bar) begin
		if (~sclr_bar) begin
			q_int = 0;
		end else if (~ld_bar) begin
			q_int = d;
		end else if (~cep_bar & ~cet_bar & up_downbar) begin
			q_int = q_int + 1;
		end else if (~cep_bar & ~cet_bar & ~up_downbar) begin
			q_int = q_int - 1;
		end
	end
end
  
assign #32 q = ~oe_bar ? q_int : 4'bzzzz; 

wire temp;
assign temp = (~cet_bar & ((up_downbar & (q_int == 15)) | (~up_downbar & (q_int == 0))));

assign #32 rco_bar = ~temp;
assign #32 cco = ~(temp & ~clk & ~cep_bar);
endmodule