// access times as good as 150ns for NMOS UV-erasable EPROM, 70ns for CMOS Flash 29FXX family

module ROM16K ( address, ce_bar, oe_bar, dout );

input [13:0] address;
input ce_bar, oe_bar;
output [7:0] dout;

parameter depth = 16384;

reg [7:0]	mem[0:depth-1];
   
assign #150 dout = (~ce_bar & ~oe_bar) ? mem[address] : 8'hzzzzzzzz;

endmodule