module Register_SP ( clk, ld_bar, cnt_bar, dir, oe_bar, d, q, rco_bar );

input clk, ld_bar, cnt_bar, dir, oe_bar;
input [7:0] d;
output [7:0] q;
output rco_bar;

wire [7:0] q;
reg [7:0] q_internal;

initial begin
  q_internal = 0;
end

always @ (posedge clk)
if (~ld_bar) begin
  q_internal = d;
end else if (~cnt_bar & dir) begin
  q_internal = q_internal + 1;
end else if (~cnt_bar & ~dir) begin
  q_internal = q_internal - 1;
end
 
assign #15 q = ~oe_bar ? q_internal : 8'bzzzzzzzz;
assign #15 rco_bar = ~(((q_internal == 255) & ~cnt_bar & dir) | ((q_internal == 0) & ~cnt_bar & ~dir));
 
endmodule
