module Registers_module ( clk, internal_data_bus, adrbus_lo, adrbus_hi, adrbus_bank, ld_y, ld_a, ld_x, ld_t, en_left_y, en_left_a, en_left_x, en_left_x7, en_left_0, en_right_t, en_right_adrlo, en_right_adrhi, en_right_adrbank, left_bus, right_bus );

input clk, ld_y, ld_a, ld_x, ld_t, en_left_y, en_left_a, en_left_x, en_left_x7, en_left_0, en_right_t, en_right_adrlo, en_right_adrhi, en_right_adrbank;
input [7:0] internal_data_bus;
input [7:0] adrbus_bank;
input [7:0] adrbus_lo;
input [7:0] adrbus_hi;
output [7:0] left_bus;
output [7:0] right_bus;
  
wire [7:0] left_bus;
wire [7:0] right_bus;

wire [7:0] a_out;
wire [7:0] x_out;
wire [7:0] y_out;
wire [7:0] t_out;

reg gnd;
reg vcc;

initial begin
  gnd = 0;
  vcc = 1;
  
  areg.q = 8'hA5;
  xreg.q = 8'hA5;
  yreg.q = 8'hA5;
  treg.q = 8'hA5;
 end
 
// the chips
Buffer_74244 u0(en_left_0, en_left_0, {gnd, gnd, gnd, gnd, gnd, gnd, gnd, gnd}, left_bus );
Register_74377 areg( clk, ld_a, internal_data_bus, a_out );
Buffer_74244 u2(en_left_a, en_left_a, a_out, left_bus );
Register_74377 xreg( clk, ld_x, internal_data_bus, x_out );
Buffer_74244 u4(en_left_x, en_left_x, x_out, left_bus );
Buffer_74244 u5(en_left_x7, en_left_x7, {x_out[7],x_out[7],x_out[7],x_out[7],x_out[7],x_out[7],x_out[7],x_out[7]}, left_bus );
Register_74377 yreg( clk, ld_y, internal_data_bus, y_out );
Buffer_74244 u6(en_left_y, en_left_y, y_out, left_bus );

Register_74377 treg( clk, ld_t, internal_data_bus, t_out );
Buffer_74244 u7(en_right_t, en_right_t, t_out, right_bus );
Buffer_74244 u8(en_right_adrlo, en_right_adrlo, adrbus_lo, right_bus );
Buffer_74244 u9(en_right_adrhi, en_right_adrhi, adrbus_hi, right_bus );
Buffer_74244 u10(en_right_adrbank, en_right_adrbank, adrbus_bank, right_bus );

endmodule
