// access times are 70ns max for CMOS SRAM 1Mbit

module SRAM128K ( address, cs1_bar, cs2, oe_bar, we_bar, d );

input [16:0] address;
input cs1_bar, cs2, oe_bar, we_bar;
inout [7:0] d;

parameter depth = 131072;

reg [7:0]	mem[0:depth-1];
   
always @ ( address, cs1_bar, cs2, we_bar, d )
if (~cs1_bar & cs2 & ~we_bar) begin
	mem[address] = d;
end


assign #70 d = (~cs1_bar & cs2 & ~oe_bar) ? mem[address] : 8'bzzzzzzzz;

endmodule