// clk_inhibit should be changed to high only when clk is high
// asynchronous clear
// worst case propagation delay is 30ns for 74LS166 (typical 19), high to low output from clear

module Shifter_74166 ( clk, clr_bar, clk_inhibit, shift_loadbar, serial_in, data_in, q );
input clk, clr_bar, clk_inhibit, shift_loadbar, serial_in;
input [7:0] data_in;
output q;

reg [7:0] internal;
   	 
always @ (clr_bar)
if (~clr_bar) begin
  internal = 0;
end

always @ (posedge clk)
if (clr_bar && ~clk_inhibit) begin
  if (~shift_loadbar) begin
    internal = data_in;
  end
  else begin
    internal[0] = internal[1];
    internal[1] = internal[2];
    internal[2] = internal[3];
    internal[3] = internal[4];
    internal[4] = internal[5];
    internal[5] = internal[6];
    internal[6] = internal[7];
    internal[7] = serial_in;
  end
end

assign #30 q = internal[0];

endmodule