// asynchronous clear
// worst case propagation delay is 30ns for 74LS194A (typical 19), high to low output from clear

module Shifter_74LS194A ( clk, clr_bar, s0, s1, dsr, dsl, data_in, q );
input clk, clr_bar, s0, s1, dsr, dsl;
input [3:0] data_in;
output [3:0] q;

reg [3:0] internal;
   	 
always @ (clr_bar)
if (~clr_bar) begin
  internal = 0;
end

always @ (posedge clk)
if (clr_bar) begin
  if (s0 & s1) begin
    internal = data_in;
  end
  else if (~s0 & s1) begin // shift right (datasheet calls this left?)
    internal[0] = internal[1];
    internal[1] = internal[2];
    internal[2] = internal[3];
    internal[3] = dsl;
  end
  else if (s0 & ~s1) begin // shift left (right?)
    internal[3] = internal[2];
    internal[2] = internal[1];
    internal[1] = internal[0];
    internal[0] = dsr;
  end
end

assign #30 q = internal;

endmodule