; some random assembler usage examples:

; !source "include.a"
; !byte 123
; !word a - b

!macro inc16 .a {
		inc .a
		bne +
		inc .a+1
+
}

; constants
	normal = 1
	
!if normal = 1 {
	Result_Pass	= $5A
} else {
	Result_Pass	= $AA
	!text "ABCDEFG", 0
}
	
* = $0

; test NOP
nop

; test loading the condition codes and positive/set branching
; -- branches taken, forward
; carry
	lda #%11110111 ; note reversed format: /C N /Z /V
	spa
	bcs +
	halt
; negative
+	lda #%00000101
	spa
	bmi +
	halt
; zero
+	lda #%11111101
	spa
	beq +
	halt
; overflow
+	lda #%00000000
	spa
	bvs +
	halt

; unconditional
+	bra +
	halt
	
; -- branches taken, backward
; carry
+	lda #%11110111 ; note reversed format: /C N /Z /V
	spa
	jmp +
-	jmp ++	
+	bcs -
	halt
; negative
++	lda #%00000100
	spa
	jmp +
-	jmp ++	
+	bmi -
	halt
; zero
++	lda #%11111101
	spa
	jmp +
-	jmp ++	
+	beq -
	halt
;overflow
++	lda #%00000000
	spa
	jmp +
-	jmp ++	
+	bvs -
	halt
	
; unconditional
++	jmp +
-	jmp ++
+	bra -
	halt
	
			
; -- branches not taken
; carry
++	lda #%11111111 ; note reversed format: /C N /Z /V
	spa
	bcs +
	jmp ++
+	halt	
; negative	
++	lda #%00000000 
	spa
	bmi +
	jmp ++
+	halt	
; zero	
++	lda #%11111111 
	spa
	beq +
	jmp ++
+	halt	
; overflow	
++	lda #%00000001 
	spa
	bvs +
	jmp ++
+	halt	

; -- branches taken, forward, across page boundary	
++	jmp +
!align $ff, $c0 ; // advance to page offset 192
+

; carry
	lda #%11110111 ; note reversed format: /C N /Z /V
	spa
	bcs BCSForwardPageBoundaryTarget
	halt
; negative
BCSForwardPageBoundaryContinue
	lda #%00000100
	spa
	bmi BMIForwardPageBoundaryTarget
	halt
; zero
BMIForwardPageBoundaryContinue
	lda #%11111101
	spa
	beq BEQForwardPageBoundaryTarget
	halt
; overflow
BEQForwardPageBoundaryContinue
	lda #%00000000
	spa
	bvs BVSForwardPageBoundaryTarget
	halt

; unconditional
BVSForwardPageBoundaryContinue
	bra BRAForwardPageBoundaryTarget
	halt
		
BRAForwardPageBoundaryContinue
	jmp BackwardPageBoundaryTests
	
!align $ff, $00 ; // advance to page offset 0
BCSForwardPageBoundaryTarget
	jmp BCSForwardPageBoundaryContinue
BMIForwardPageBoundaryTarget
	jmp BMIForwardPageBoundaryContinue
BEQForwardPageBoundaryTarget
	jmp BEQForwardPageBoundaryContinue
BVSForwardPageBoundaryTarget
	jmp BVSForwardPageBoundaryContinue
BRAForwardPageBoundaryTarget
	jmp BRAForwardPageBoundaryContinue
	
!align $ff, $f0 ; // advance to page offset 240
BCSBackwardPageBoundaryTarget
	jmp BCSBackwardPageBoundaryContinue
BMIBackwardPageBoundaryTarget
	jmp BMIBackwardPageBoundaryContinue
BEQBackwardPageBoundaryTarget
	jmp BEQBackwardPageBoundaryContinue
BVSBackwardPageBoundaryTarget
	jmp BVSBackwardPageBoundaryContinue
BRABackwardPageBoundaryTarget
	jmp BRABackwardPageBoundaryContinue
		
; -- branches taken, backward, across page boundary	
!align $ff, $00 ; // advance to page offset 0		
BackwardPageBoundaryTests
; carry
	lda #%11110111 ; note reversed format: /C N /Z /V
	spa
	bcs BCSBackwardPageBoundaryTarget
	halt
; negative
BCSBackwardPageBoundaryContinue
	lda #%00000100
	spa
	bmi BMIBackwardPageBoundaryTarget
	halt
; zero
BMIBackwardPageBoundaryContinue
	lda #%11111101
	spa
	beq BEQBackwardPageBoundaryTarget
	halt
; overflow
BEQBackwardPageBoundaryContinue
	lda #%00000000
	spa
	bvs BVSBackwardPageBoundaryTarget
	halt	

; unconditional
BVSBackwardPageBoundaryContinue			
	bra BRABackwardPageBoundaryTarget
	halt
	
BRABackwardPageBoundaryContinue

; test loading the condition codes and negative/clear branching
; -- branches taken, forward
; carry
	lda #%00001000 ; note reversed format: /C N /Z /V
	spa
	bcc +
	halt
; negative/zero
+	lda #%11111011
	spa
	bpl +
	halt
; zero
+	lda #%00000010
	spa
	bne +
	halt
; overflow
+	lda #%11111111
	spa
	bvc +
	halt

; -- branches taken, backward
; carry
+	lda #%00001000 ; note reversed format: /C N /Z /V
	spa
	jmp +
-	jmp ++	
+	bcc -
	halt
; negative/zero
++	lda #%11111011
	spa
	jmp +
-	jmp ++	
+	bpl -
	halt
; zero
++	lda #%00000010
	spa
	jmp +
-	jmp ++	
+	bne -
	halt
;overflow
++	lda #%11111111
	spa
	jmp +
-	jmp ++	
+	bvc -
	halt		
			
; -- branches not taken
; carry
++	lda #%00000000 ; note reversed format: /C N /Z /V
	spa
	bcc +
	jmp ++
+	halt	
; negative/zero	
++	lda #%11111111
	spa
	bpl +
	jmp ++
+	halt	
; zero	
++	lda #%00000000 
	spa
	bne +
	jmp ++
+	halt	
; overflow	
++	lda #%11111110 
	spa
	bvc +
	jmp ++
+	halt	

; -- branches taken, forward, across page boundary	
++	jmp +
!align $ff, $c0 ; // advance to page offset 192
+

; carry
	lda #%00001000 ; note reversed format: /C N /Z /V
	spa
	bcc BCCForwardPageBoundaryTarget
	halt
; negative/zero
BCCForwardPageBoundaryContinue
	lda #%11111011
	spa
	bpl BPLForwardPageBoundaryTarget
	halt
; zero
BPLForwardPageBoundaryContinue
	lda #%00000010
	spa
	bne BNEForwardPageBoundaryTarget
	halt
; overflow
BNEForwardPageBoundaryContinue
	lda #%11111111
	spa
	bvc BVCForwardPageBoundaryTarget
	halt
	
BVCForwardPageBoundaryContinue
	jmp BackwardPageBoundaryTests2
	
!align $ff, $00 ; // advance to page offset 0
BCCForwardPageBoundaryTarget
	jmp BCCForwardPageBoundaryContinue
BPLForwardPageBoundaryTarget
	jmp BPLForwardPageBoundaryContinue
BNEForwardPageBoundaryTarget
	jmp BNEForwardPageBoundaryContinue
BVCForwardPageBoundaryTarget
	jmp BVCForwardPageBoundaryContinue

!align $ff, $f0 ; // advance to page offset 240
BCCBackwardPageBoundaryTarget
	jmp BCCBackwardPageBoundaryContinue
BPLBackwardPageBoundaryTarget
	jmp BPLBackwardPageBoundaryContinue
BNEBackwardPageBoundaryTarget
	jmp BNEBackwardPageBoundaryContinue
BVCBackwardPageBoundaryTarget
	jmp BVCBackwardPageBoundaryContinue
	
; -- branches taken, backward, across page boundary	
!align $ff, $00 ; // advance to page offset 0		
BackwardPageBoundaryTests2
; carry
	lda #%00001000 ; note reversed format: /C N /Z /V
	spa
	bcc BCCBackwardPageBoundaryTarget
	halt
; negative/zero
BCCBackwardPageBoundaryContinue
	lda #%11111011
	spa
	bpl BPLBackwardPageBoundaryTarget
	halt
; zero
BPLBackwardPageBoundaryContinue
	lda #%00000010
	spa
	bne BNEBackwardPageBoundaryTarget
	halt
; overflow
BNEBackwardPageBoundaryContinue
	lda #%11111111
	spa
	bvc BVCBackwardPageBoundaryTarget
	halt	

BVCBackwardPageBoundaryContinue	

; test BPL with one of 2 flags satisfied
	lda #%11111001 ; note reversed format: /C N /Z /V
	spa
	bpl +
	lda #%11111111 
	spa
	bpl +
	jmp ++
+	halt
	
; If we got this far, then the branching instructions work.

; V generation - adding
++	clc
	lda #$70
	adc #$0f
	bvc +
	halt
+	sec
	lda #$70
	adc #$0f
	bvs +
	halt
+	clc
	lda #-2
	adc #-3
	bvc +
	halt
+	clc
	lda #-127
	adc #-1
	bvc +
	halt
+	clc
	lda #-128
	adc #-1
	bvs +
	halt
+	sec
	lda #-128
	adc #-1
	bvc +
	halt
+	clc
	lda #-128
	adc #127
	bvc +
	halt
+	clc
	lda #127
	adc #-128
	bvc +
	halt
+	clc
	lda #127
	adc #-127
	bvc +
	halt

; V generation for increment/decrement does not work

; V generation - subtract
+	sec
	lda #-127
	sbc #1
	bvc +
	halt
+	clc
	lda #-127
	sbc #1
	bvs +
	halt
+	sec
	lda #127
	sbc #-1
	bvs +
	halt
+
		
; CMP immediate - equal
++	lda #$7f
	cmp #$7f
	bne +
	bcc +
	bvs +
	bpl +
	bmi +
	jmp ++
+	halt

; CMP immediate - greater
++	lda #$79
	cmp #$78
	beq +
	bcc +
	bvs +
	bmi +
	jmp ++
+	halt

; CMP immediate - less
++	lda #$78
	cmp #$79
	beq +
	bcs +
	bvs +
	bpl +
	jmp ++
+	halt
	
; CMP immediate - overflow
++	lda #$80
	cmp #$01
	beq +
	bcc +
	bvc +
	bmi +
	jmp ++
+	halt


; CPX immediate - equal
++	ldx #$79
	cpx #$79
	bne +
	bcc +
	bvs +
	bpl +
	bmi +
	jmp ++
+	halt

; CPX immediate - greater
++	ldx #$79
	cpx #$78
	beq +
	bcc +
	bvs +
	bmi +
	jmp ++
+	halt

; CPX immediate - less
++	ldx #$78
	cpx #$79
	beq +
	bcs +
	bvs +
	bpl +
	jmp ++
+	halt
	
; CPX immediate - overflow
++	ldx #$80
	cpx #$01
	beq +
	bcc +
	bvc +
	bmi +
	jmp ++
+	halt


; CPY immediate - equal
++	ldy #$79
	cpy #$79
	bne +
	bcc +
	bvs +
	bpl +
	bmi +
	jmp ++
+	halt

; CPY immediate - greater
++	ldy #$79
	cpy #$78
	beq +
	bcc +
	bvs +
	bmi +
	jmp ++
+	halt

; CPY immediate - less
++	ldy #$78
	cpy #$79
	beq +
	bcs +
	bvs +
	bpl +
	jmp ++
+	halt
	
; CPY immediate - overflow
++	ldy #$80
	cpy #$01
	beq +
	bcc +
	bvc +
	bmi +
	jmp ++
+	halt

; PHA/PLA
++	pha ; At boot, SP=0. Perform a dummy PHA to make SP wrap to $FFFF
	lda #$38
	pha
	lda #$ff
	pla
	cmp #$38
	beq +
	halt

; PHX/PLX
+	ldx #$38
	phx
	ldx #$ff
	plx
	cpx #$38
	beq +
	halt
	
; STA/LDA absolute
+	lda #$37
	sta $4000 ; first byte of RAM
	lda #$ff
	lda $4000
	cmp #$37
	beq +
	halt

; JMP indirect
+	lda #<JMPIndirectTarget ; low byte of address
	sta $4000
	lda #>JMPIndirectTarget ; high byte of address
	sta $4001
	jmp ($4000)
	halt
	
JMPIndirectTarget	
; JSR absolute
	lda #0
	jsr JSRIndirectSubroutine
	cmp #$39
	beq +
	halt

JSRIndirectSubroutine
	lda #$39
	rts

; PHP/PLP
+	lda #%00001111 ; note reversed format: /C N /Z /V
	spa
	lda #$78
	php
	cmp #$78
	beq +
	halt
+	lda #%00000000
	spa
	lda #$79
	plp
	bcs +
	bpl +
	beq +
	bvs +
	cmp #$79
	bne +
	jmp ++
+	halt

++	lda #%00001010 ; note reversed format: /C N /Z /V
	spa
	lda #$ff
	php
	pla
	cmp #%00001010
	beq +
	halt
		
; SEC/CLC
+	lda #%11111111 ; note reversed format: /C N /Z /V
	spa
	sec
	bcc +
	jmp ++
+	halt


++	lda #%00000000 ; note reversed format: /C N /Z /V
	spa
	clc
	bcs +
	jmp ++
+	halt

; CLV
++	lda #%00000000 ; note reversed format: /C N /Z /V
	spa
	clv
	bvs +
	jmp ++
+	halt

; SEI/CLI
++	cli
	sei	
	

; INC A
	lda #$07
	inc 
	cmp #$08
	beq +
	halt
+	lda #$ff
	inc 
	bcc +
	bne +
	cmp #$00
	bne +
	jmp ++		
+	halt
	
; INX
++	ldx #$07
	inx
	cpx #$08
	beq +
	halt
+	ldx #$ff
	inx
	bcc +
	bne +
	cpx #$00
	bne +
	jmp ++		
+	halt

; INY
++	ldy #$07
	iny
	cpy #$08
	beq +
	halt
+	ldy #$ff
	iny
	bcc +
	bne +
	cpy #$00
	bne +
	jmp ++		
+	halt

; ORA
++	lda #%11111000
	ora #%00011110
	beq +
	cmp #%11111110
	bne +
	jmp ++
+	halt
; AND
++	lda #%11111000
	and #%00011110
	beq +
	cmp #%00011000
	bne +
	jmp ++
+	halt
; EOR
++	lda #%11111000
	eor #%00011110
	beq +
	cmp #%11100110
	bne +
	jmp ++
+	halt

; ADC
++	clc
	lda #$74
	adc #$02
	cmp #$76
	beq +
	halt
+	sec
	adc #$02
	cmp #$79
	beq +
	halt
+	clc
	lda #$fe
	adc #$01
	bcc +
	halt
+	sec
	lda #$fe
	adc #$01
	bcc +
	bne +
	jmp ++
+	halt

; 16-bit add
++	lda #$fe
	sta $4000
	lda #$0
	sta $4001
	clc
	lda $4000
	adc #$02
	sta $4000
	lda $4001
	adc #$00
	cmp #$01
	beq +
	halt
	
; SBC
+	sec
	lda #$74
	sbc #$02
	cmp #$72
	beq +
	halt	
+	clc
	sbc #$02
	cmp #$6F
	beq +
	halt
+	sec
	lda #$01
	sbc #$01
	bcs +
	halt
+	clc
	lda #$01
	adc #$01
	bcs +
	beq +
	jmp ++
+	halt	
	
; 16-bit subtract
++	lda #$01
	sta $4000
	lda #$07
	sta $4001
	sec
	lda $4000
	sbc #$02
	sta $4000
	lda $4001
	sbc #$00
	cmp #$06
	beq +
	halt
	
; ASL
+	sec
	lda #%11111111
	asl
	bcc +
	cmp #%11111110
	bne +
	jmp ++
+	halt
++	lda #%00101010
	asl
	bcs +
	cmp #%01010100
	bne +
	jmp ++
+	halt

; LSR
++	sec
	lda #%11111111
	lsr
	bcc +
	cmp #%01111111
	bne +
	jmp ++
+	halt
++	lda #%01010100
	lsr
	bcs +
	cmp #%00101010
	bne +
	jmp ++
+	halt

; ROL
++	sec
	lda #%00001111
	rol
	bcc +
	halt
+	cmp #%00011111
	beq +
	halt
+	clc
	lda #%10001111
	rol
	bcs +
	halt
+	cmp #%00011110
	beq +
	halt

; ROR		
+	sec
	lda #%10001110
	ror
	bcc +
	halt
+	cmp #%11000111
	beq +
	halt
+	clc
	lda #%10001111
	ror
	bcs +
	halt
+	cmp #%01000111
	beq +
	halt

; TXA/TAX	
+	ldx #$fe
	lda #$00
	txa
	cmp #$fe
	beq +
	halt
+	lda #$17
	ldx #$be
	tax
	cpx #$17
	beq +
	halt

; TYA/TAY	
+	ldy #$fe
	lda #$00
	tya
	cmp #$fe
	beq +
	halt
+	lda #$17
	ldy #$be
	tay
	cpy #$17
	beq +
	halt
	
; DEC A	
+	lda #$07
	dec
	cmp #$06
	beq +
	halt
+	lda #$00
	dec
	bcs +
	beq +
	bpl +
	cmp #$ff
	bne +
	jmp ++		
+	halt

; DEX	
++	ldx #$07
	dex
	cpx #$06
	beq +
	halt
+	ldx #$00
	dex
	bcs +
	beq +
	bpl +
	cpx #$ff
	bne +
	jmp ++		
+	halt	

; DEY	
++	ldy #$07
	dey
	cpy #$06
	beq +
	halt
+	ldy #$00
	dey
	bcs +
	beq +
	bpl +
	cpy #$ff
	bne +
	jmp ++		
+	halt

; BIT immediate
++	lda #%11111000
	bit #%00011110
	bne +
	halt
+	cmp #%11111000
	beq +
	halt
+	lda #%11100000
	bit #%00011110
	beq +
	halt
+	cmp #%11100000
	beq +
	halt
	
; BIT
+	lda #%00011110
	sta $4000
	lda #%11111000
	bit $4000
	bne +
	halt
+	cmp #%11111000
	beq +
	halt
+	lda #%00011110
	sta $4000
	lda #%11100000
	bit $4000
	beq +
	halt
+	cmp #%11100000
	beq +
	halt

; ORA absolute, absolute,X	
+	lda #%00011110
	sta $4000
	lda #%11111000
	ora $4000
	beq +
	cmp #%11111110
	bne +
	jmp ++
+	halt	
++	lda #%00011110
	sta $4009
	lda #%11111000
	ldx #$05
	ora $4004,X
	beq +
	cmp #%11111110
	bne +
	jmp ++
+	halt
++	lda #%00011110
	sta $4102
	lda #%11111000
	ldx #$05
	ora $40FD,X
	beq +
	cmp #%11111110
	bne +
	jmp ++
+	halt

; AND absolute, absolute,X	
++	lda #%00011110
	sta $4000
	lda #%11111000
	and $4000
	beq +
	cmp #%00011000
	bne +
	jmp ++
+	halt	
++	lda #%00011110
	sta $4009
	lda #%11111000
	ldx #$05
	and $4004,X
	beq +
	cmp #%00011000
	bne +
	jmp ++
+	halt
++	lda #%00011110
	sta $4102
	lda #%11111000
	ldx #$05
	and $40FD,X
	beq +
	cmp #%00011000
	bne +
	jmp ++
+	halt
	 

; EOR absolute, absolute,X	
++	lda #%00011110
	sta $4000
	lda #%11111000
	eor $4000
	beq +
	cmp #%11100110
	bne +
	jmp ++
+	halt	
++	lda #%00011110
	sta $4009
	lda #%11111000
	ldx #$05
	eor $4004,X
	beq +
	cmp #%11100110
	bne +
	jmp ++
+	halt
++	lda #%00011110
	sta $4102
	lda #%11111000
	ldx #$05
	eor $40FD,X
	beq +
	cmp #%11100110
	bne +
	jmp ++
+	halt

; ADC absolute
++	clc
	lda #$02
	sta $4000
	lda #$74
	adc $4000
	cmp #$76
	beq +
	halt
+	sec
	adc $4000
	cmp #$79
	beq +
	halt
+	clc
	lda #$01
	sta $4000
	lda #$fe
	adc $4000
	bcc +
	halt
+	sec
	lda #$fe
	adc $4000
	bcc +
	bne +
	jmp ++
+	halt	
 
; ADC absolute,X
; no carry in, no carry out, no page boundary crossing
++	clc
	lda #$02
	sta $4009
	lda #$74
	ldx #$05
	adc $4004,X
	bcs +
	cmp #$76
	bne +
	jmp ++
+	halt
; carry in, no carry out, no page boundary crossing	
++	sec
	lda #$02
	sta $4009
	lda #$74
	ldx #$05
	adc $4004,X
	bcs +
	cmp #$77
	bne +
	jmp ++
+	halt
; no carry in, carry out, no page boundary crossing	
++	clc
	lda #$ff
	sta $4009
	lda #$74
	ldx #$05
	adc $4004,X
	bcc +
	cmp #$73
	bne +
	jmp ++
+	halt
; carry in, carry out, no page boundary crossing	
++	sec
	lda #$01
	sta $4009
	lda #$fe
	ldx #$05
	adc $4004,X
	bcc +
	cmp #$00
	bne +
	jmp ++
+	halt
; no carry in, no carry out, page boundary crossing
++	clc
	lda #$02
	sta $4102
	lda #$74
	ldx #$05
	adc $40FD,X
	bcs +
	cmp #$76
	bne +
	jmp ++
+	halt
; carry in, no carry out, page boundary crossing	
++	sec
	lda #$02
	sta $4102
	lda #$74
	ldx #$05
	adc $40FD,X
	bcs +
	cmp #$77
	bne +
	jmp ++
+	halt
; no carry in, carry out, page boundary crossing	
++	clc
	lda #$ff
	sta $4102
	lda #$74
	ldx #$05
	adc $40FD,X
	bcc +
	cmp #$73
	bne +
	jmp ++
+	halt
; carry in, carry out, page boundary crossing	
++	sec
	lda #$01
	sta $4102
	lda #$fe
	ldx #$05
	adc $40FD,X
	bcc +
	cmp #$00
	bne +
	jmp ++
+	halt

; STA abs,X, LDA abs,X
++	lda #$e3
	ldx #$05
	sta $4000,X
	lda #00
	ldx #$03
	lda $4002,X
	cmp #$e3
	beq +
	halt

; CMP abs - equal
+	lda #$79
	sta $4000
	lda #$79
	cmp $4000
	bne +
	bcc +
	bvs +
	bpl +
	bmi +
	jmp ++
+	halt

; CMP abs - greater
++	lda #$78
	sta $4000
	lda #$79
	cmp $4000
	beq +
	bcc +
	bvs +
	bmi +
	jmp ++
+	halt

; CMP abs - less
++	lda #$79
	sta $4000
	lda #$78
	cmp $4000
	beq +
	bcs +
	bvs +
	bpl +
	jmp ++
+	halt
	
; CMP abs - overflow
++	lda #$01
	sta $4000
	lda #$80
	cmp $4000
	beq +
	bcc +
	bvc +
	bmi +
	jmp ++
+	halt


; CMP abs,X - equal
++	lda #$79
	sta $4009
	lda #$79
	ldx #$05
	cmp $4004,X	
	bne +
	bcc +
	bvs +
	bpl +
	bmi +
	jmp ++
+	halt


; CMP abs,X - greater
++	lda #$78
	sta $4009
	lda #$79
	ldx #$05	
	cmp $4004,X
	beq +
	bcc +
	bvs +
	bmi +
	jmp ++
+	halt

; CMP abs,X - less
++	lda #$79
	sta $4009
	lda #$78
	ldx #$05	
	cmp $4004,X
	beq +
	bcs +
	bvs +
	bpl +
	jmp ++
+	halt
	
; CMP abs,X - overflow
++	lda #$01
	sta $4009
	lda #$80
	ldx #$05	
	cmp $4004,X
	beq +
	bcc +
	bvc +
	bmi +
	jmp ++
+	halt

; CMP abs,X - equal, across page boundary
++	lda #$79
	sta $4102
	lda #$79
	ldx #$05
	cmp $40FD,X	
	bne +
	bcc +
	bvs +
	bpl +
	bmi +
	jmp ++
+	halt


; CMP abs,X - greater, across page boundary
++	lda #$78
	sta $4102
	lda #$79
	ldx #$05	
	cmp $40FD,X
	beq +
	bcc +
	bvs +
	bmi +
	jmp ++
+	halt

; CMP abs,X - less, across page boundary
++	lda #$79
	sta $4102
	lda #$78
	ldx #$05	
	cmp $40FD,X
	beq +
	bcs +
	bvs +
	bpl +
	jmp ++
+	halt
	
; CMP abs,X - overflow, across page boundary
++	lda #$01
	sta $4102
	lda #$80
	ldx #$05	
	cmp $40FD,X
	beq +
	bcc +
	bvc +
	bmi +
	jmp ++
+	halt


; CPX abs - equal
++	ldx #$79
	stx $4000
	ldx #$79
	cpx $4000
	bne +
	bcc +
	bvs +
	bpl +
	bmi +
	jmp ++
+	halt

; CPX abs - greater
++	ldx #$78
	stx $4000
	ldx #$79
	cpx $4000
	beq +
	bcc +
	bvs +
	bmi +
	jmp ++
+	halt

; CPX abs - less
++	ldx #$79
	stx $4000
	ldx #$78
	cpx $4000
	beq +
	bcs +
	bvs +
	bpl +
	jmp ++
+	halt
	
; CPX abs - overflow
++	ldx #$01
	stx $4000
	ldx #$80
	cpx $4000
	beq +
	bcc +
	bvc +
	bmi +
	jmp ++
+	halt


; CPY abs - equal
++	ldy #$79
	sty $4000
	ldy #$79
	cpy $4000
	bne +
	bcc +
	bvs +
	bpl +
	bmi +
	jmp ++
+	halt

; CPY abs - greater
++	ldy #$78
	sty $4000
	ldy #$79
	cpy $4000
	beq +
	bcc +
	bvs +
	bmi +
	jmp ++
+	halt

; CPY abs - less
++	ldy #$79
	sty $4000
	ldy #$78
	cpy $4000
	beq +
	bcs +
	bvs +
	bpl +
	jmp ++
+	halt
	
; CPY abs - overflow
++	ldy #$01
	sty $4000
	ldy #$80
	cpy $4000
	beq +
	bcc +
	bvc +
	bmi +
	jmp ++
+	halt
		
; SBC absolute
++	sec
	lda #$02
	sta $4000
	lda #$74
	sbc $4000
	cmp #$72
	beq +
	halt
+	clc
	sbc $4000
	cmp #$6F
	beq +
	halt
+	sec
	lda #$01
	sta $4000
	lda #$01
	sbc $4000
	bcs +
	halt
+	clc
	lda #$01
	sbc $4000
	bcs +
	beq +
	jmp ++
+	halt
	
; SBC absolute,X
; no carry in, no carry out, no page boundary crossing
++	clc
	lda #$02
	sta $4009
	lda #$74
	ldx #$05
	sbc $4004,X
	bcc +
	cmp #$71
	bne +
	jmp ++
+	halt
; carry in, no carry out, no page boundary crossing	
++	sec
	lda #$02
	sta $4009
	lda #$74
	ldx #$05
	sbc $4004,X
	bcc +
	cmp #$72
	bne +
	jmp ++
+	halt
; no carry in, carry out, no page boundary crossing	
++	clc
	lda #$fe
	sta $4009
	lda #$74
	ldx #$05
	sbc $4004,X
	bcs +
	cmp #$75
	bne +
	jmp ++
+	halt
; carry in, carry out, no page boundary crossing	
++	sec
	lda #$02
	sta $4009
	lda #$01
	ldx #$05
	sbc $4004,X
	bcs +
	cmp #$ff
	bne +
	jmp ++
+	halt
; no carry in, no carry out, page boundary crossing
++	clc
	lda #$02
	sta $4102
	lda #$74
	ldx #$05
	sbc $40FD,X
	bcc +
	cmp #$71
	bne +
	jmp ++
+	halt
; carry in, no carry out, page boundary crossing	
++	sec
	lda #$02
	sta $4102
	lda #$74
	ldx #$05
	sbc $40FD,X
	bcc +
	cmp #$72
	bne +
	jmp ++
+	halt
; no carry in, carry out, page boundary crossing	
++	clc
	lda #$fe
	sta $4102
	lda #$74
	ldx #$05
	sbc $40FD,X
	bcs +
	cmp #$75
	bne +
	jmp ++
+	halt
; carry in, carry out, page boundary crossing	
++	sec
	lda #$02
	sta $4102
	lda #$01
	ldx #$05
	sbc $40FD,X
	bcs +
	cmp #$ff
	bne +
	jmp ++
+	halt

; LDX/STX absolute	
++	ldx #$37
	stx $4000 ; first byte of RAM
	ldx #$ff
	ldx $4000
	cpx #$37
	beq +
	halt

; LDY/STY absolute	
++	ldy #$37
	sty $4000 ; first byte of RAM
	ldy #$ff
	ldy $4000
	cpy #$37
	beq +
	halt
	
; INC absolute
+	lda #$04
	sta $4000
	inc $4000
	bcs +
	lda $4000
	cmp #$05
	bne +
	jmp ++
+	halt
++	lda #$ff
	sta $4000
	inc $4000
	bcc +
	lda $4000
	cmp #$00
	bne +
	jmp ++
+	halt

; INC absolute,X, no page boundary crossing
+	lda #$04
	sta $4009
	ldx #$05
	inc $4004,X
	bcs +
	lda $4009
	cmp #$05
	bne +
	jmp ++
+	halt
++	lda #$ff
	sta $4009
	ldx #$05	
	inc $4004,X
	bcc +
	lda $4009
	cmp #$00
	bne +
	jmp ++
+	halt

; INC absolute,X, page boundary crossing
+	lda #$04
	sta $4102
	ldx #$05
	inc $40FD,X
	bcs +
	lda $4009
	cmp #$05
	bne +
	jmp ++
+	halt
++	lda #$ff
	sta $4102
	ldx #$05	
	inc $40FD,X
	bcc +
	lda $4009
	cmp #$00
	bne +
	jmp ++
+	halt

; DEC absolute
++	lda #$04
	sta $4000
	dec $4000
	bcc +
	lda $4000
	cmp #$03
	bne +
	jmp ++
+	halt
++	lda #$00
	sta $4000
	dec $4000
	bcs +
	lda $4000
	cmp #$ff
	bne +
	jmp ++
+	halt

; DEC absolute,X, no page boundary crossing
+	lda #$04
	sta $4009
	ldx #$05
	dec $4004,X
	bcc +
	lda $4009
	cmp #$03
	bne +
	jmp ++
+	halt
++	lda #$00
	sta $4009
	ldx #$05	
	dec $4004,X
	bcs +
	lda $4009
	cmp #$ff
	bne +
	jmp ++
+	halt

; DEC absolute,X, page boundary crossing
+	lda #$04
	sta $4102
	ldx #$05
	dec $40FD,X
	bcc +
	lda $4009
	cmp #$03
	bne +
	jmp ++
+	halt
++	lda #$00
	sta $4102
	ldx #$05	
	dec $40FD,X
	bcs +
	lda $4009
	cmp #$ff
	bne +
	jmp ++
+	halt

; ASL abs
++	sec
	lda #%11111111
	sta $4000
	lda #$0
	asl $4000
	bcc +
	lda $4000
	cmp #%11111110
	bne +
	jmp ++
+	halt
++	lda #%00101010
	sta $4000
	lda #$0
	asl $4000
	bcs +
	lda $4000	
	cmp #%01010100
	bne +
	jmp ++
+	halt

; LSR abs
++	sec
	lda #%11111111
	sta $4000
	lda #$0	
	lsr $4000
	bcc +
	lda $4000	
	cmp #%01111111
	bne +
	jmp ++
+	halt
++	lda #%01010100
	sta $4000
	lda #$0	
	lsr $4000
	bcs +
	lda $4000	
	cmp #%00101010
	bne +
	jmp ++
+	halt

; ROL abs
++	sec
	lda #%00001111
	sta $4000
	lda #$0	
	rol $4000
	bcc +
	halt
+	lda $4000
	cmp #%00011111
	beq +
	halt
+	clc
	lda #%10001111
	sta $4000
	lda #$0	
	rol $4000
	bcs +
	halt
+	lda $4000
	cmp #%00011110
	beq +
	halt
; ROR abs		
+	sec
	lda #%10001110
	sta $4000
	lda #$0	
	ror $4000
	bcc +
	halt
+	lda $4000
	cmp #%11000111
	beq +
	halt
+	clc
	lda #%10001111
	sta $4000
	lda #$0	
	ror $4000
	bcs +
	halt
+	lda $4000
	cmp #%01000111
	beq +
	halt

; ASL abs,X, no page boundary crossing
+
++	sec
	lda #%11111111
	sta $4009
	lda #$0
	ldx #$05
	asl $4004,X
	bcc +
	lda $4009
	cmp #%11111110
	bne +
	jmp ++
+	halt
++	lda #%00101010
	sta $4009
	lda #$0
	ldx #$05
	asl $4004,X
	bcs +
	lda $4009	
	cmp #%01010100
	bne +
	jmp ++
+	halt

; LSR abs,X, no page boundary crossing
++	sec
	lda #%11111111
	sta $4009
	lda #$0	
	ldx #$05
	lsr $4004,X
	bcc +
	lda $4009	
	cmp #%01111111
	bne +
	jmp ++
+	halt
++	lda #%01010100
	sta $4009
	lda #$0	
	ldx #$05
	lsr $4004,X
	bcs +
	lda $4009	
	cmp #%00101010
	bne +
	jmp ++
+	halt

; ROL abs,X, no page boundary crossing
++	sec
	lda #%00001111
	sta $4009
	lda #$0	
	ldx #$05
	rol $4004,X
	bcc +
	halt
+	lda $4009
	cmp #%00011111
	beq +
	halt	
+	clc
	lda #%10001111
	sta $4009
	lda #$0	
	ldx #$05
	rol $4004,X
	bcs +
	halt
+	lda $4009
	cmp #%00011110
	beq +
	halt	
; ROR abs,X, no page boundary crossing	
+	sec
	lda #%10001110
	sta $4009
	lda #$0	
	ldx #$05
	ror $4004,X
	bcc +
	halt
+	lda $4009
	cmp #%11000111
	beq +
	halt
+	clc
	lda #%10001111
	sta $4009
	lda #$0	
	ldx #$05
	ror $4004,X
	bcs +
	halt
+	lda $4009
	cmp #%01000111
	beq +
	halt

; ASL abs,X, page boundary crossing
+
++	sec
	lda #%11111111
	sta $4102
	lda #$0
	ldx #$05
	asl $40FD,X
	bcc +
	lda $4102
	cmp #%11111110
	bne +
	jmp ++
+	halt
++	lda #%00101010
	sta $4102
	lda #$0
	ldx #$05
	asl $40FD,X
	bcs +
	lda $4102	
	cmp #%01010100
	bne +
	jmp ++
+	halt

; LSR abs,X, page boundary crossing
++	sec
	lda #%11111111
	sta $4102
	lda #$0	
	ldx #$05
	lsr $40FD,X
	bcc +
	lda $4102	
	cmp #%01111111
	bne +
	jmp ++
+	halt
++	lda #%01010100
	sta $4102
	lda #$0	
	ldx #$05
	lsr $40FD,X
	bcs +
	lda $4102	
	cmp #%00101010
	bne +
	jmp ++
+	halt

; ROL abs,X, page boundary crossing
++	sec
	lda #%00001111
	sta $4102
	lda #$0	
	ldx #$05
	rol $40FD,X
	bcc +
	halt
+	lda $4102
	cmp #%00011111
	beq +
	halt
+	clc
	lda #%10001111
	sta $4102
	lda #$0	
	ldx #$05
	rol $40FD,X
	bcs +
	halt
+	lda $4102
	cmp #%00011110
	beq +
	halt
; ROR abs,X, page boundary crossing	
+	sec
	lda #%10001110
	sta $4102
	lda #$0	
	ldx #$05
	ror $40FD,X
	bcc +
	halt
+	lda $4102
	cmp #%11000111
	beq +
	halt
+	clc
	lda #%10001111
	sta $4102
	lda #$0	
	ldx #$05
	ror $40FD,X
	bcs +
	halt
+	lda $4102
	cmp #%01000111
	beq +
	halt
		
+
++	lda #Result_Pass
	halt
	
