`timescale 1ns / 1ns

module testbench;

reg	clk;
reg reset_bar;
reg dummy;
reg [23:0] count;

Top_module machine(clk, reset_bar);
	
always #500 begin
  clk = ~clk;
  count = count + 1;
end

initial
  begin
	$dumpfile("BMOW.dump");
	$dumpvars;

	count = 0;
	clk = 1;
	reset_bar = 0;
	#3200 reset_bar = 1;
	#800
		
	repeat(10000) begin
		//$monitor("%d: op=%h, intbus=%h, extbus=%h", $time, machine.contmod.op_out, machine.internal_data_bus, machine.external_data_bus);
		#1000 dummy = 0;
		if (machine.opcode == 255) begin
			if (machine.a == 90) begin // 90 = 0x5A
				$display("SUCCESS: test passed (%d clocks)", count);
			end else begin
				$display("ERROR: test failed");
			end
			$finish;
		end
	end
	$display("ERROR: test did not terminate");
	#100 $finish;
  end
 
endmodule

